#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/poll.h>
#include <stdbool.h>
#include <fcntl.h>
#include <sys/msg.h>
#include <errno.h>
#include "fss_send.h"

/*- --------------------------------------------------------- -*
 *-	Socket open & bind(Server) connect(Client)  function
 *- --------------------------------------------------------- -*/
int SetSocketTcp(addr, port, serv_cli, ebuf)
char	*addr;
long	port;
int	serv_cli;	/* server : 1, client : 2 */
char	*ebuf;
{
	struct  linger          ling;
	struct	protoent *pproto;
	struct	sockaddr_in	sin;
	int	sd,	ret,	on=1,off=0, sz_sbuf;

	bzero((char *)&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_port = htons(port);
	sin.sin_addr.s_addr = inet_addr(addr); 	 
	if((sd= socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		sprintf(ebuf, "socket() : err[%d]\n", errno);
		return(-1);
	}

	/* added to options of socket by Changseop Oh from CheongJo */
	if(setsockopt(sd,SOL_SOCKET,SO_REUSEADDR,(char*)&on,sizeof(on))<0)
		sprintf(ebuf, "setsockopt() : REUSEADDR setting Error!");

	/*- -------------------------------------------------- -*
	 *- Send Buffer Size ÷ش (8192 -> 16384)
	 *- -------------------------------------------------- -*/
	if(setsockopt(sd,SOL_SOCKET,SO_SNDBUF, (char*)&sz_sbuf,sizeof(sz_sbuf))<0)
		sprintf(ebuf, "setsockopt() : SNDBUF setting Error!");

	/*- -------------------------------------------------- -*
	 *- Socket close ϶  ޼ ó
	 *- -------------------------------------------------- -*/
	ling.l_onoff = 1;
        ling.l_linger = 0;
	if(setsockopt(sd, SOL_SOCKET, SO_LINGER, (char *)&ling, sizeof(ling)) < 0)
		sprintf(ebuf, "Set soket Linger setting Error!");

	/*- -------------------------------------------------- -*
	 *-  Socket ֳ ׾ֳ üũ
	 *- -------------------------------------------------- -*/
	if(setsockopt(sd, SOL_SOCKET, SO_KEEPALIVE, (char *)&on, sizeof(on)) < 0)
		sprintf(ebuf, "Set soket Linger setting Error!");

#ifdef BAAS_PORT_REUSE
	 ýۿ  ϳ..
	/*- -------------------------------------------------- -*
	 *- Socket Port reuse 
	 *- -------------------------------------------------- -*/
	if(setsockopt(sd, SOL_SOCKET, SO_REUSEPORT, (char *)&on, sizeof(on)) < 0){
		sprintf(ebuf, "Set Soket Reuse Port setting Error!");
		printf("Set Soket Reuse Port setting Error!\n");
	}

#endif

	/*- -------------------------------------------------- -*
	 *- TCP :  bind(), Ŭ̾Ʈ connect()
	 *- -------------------------------------------------- -*/
	if (serv_cli == 1) {
		if (bind(sd, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
			sprintf(ebuf, "bind() err[%d][%s]", errno, strerror(errno));
			close(sd);
			return(-2);
		}
		if (listen(sd, 5) < 0) {
			sprintf(ebuf, "listen() err[%d][%s]", errno, strerror(errno));
			close(sd);
			return(-3);
		}
		return(sd);
	}
	if (connect(sd, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
		sprintf(ebuf, "connect() err[%d][%s]", errno, strerror(errno));
		printf("connect() err[%d][%s]\n", errno, strerror(errno));
		close(sd);
		ret = (errno + 10000) * (-1);
		return(ret);
	}		
	return(sd);
}

int main(int argc, char *argv[])
{
	char ebuf[4096];
	char tmp[4096];
	int sock, ii, kk, ff;

	FILE *fp=NULL;

	if(argc != 2)
	{
		printf("%s /home/pkcmcspw/test/undo/fss_stock/krx_data/KRX_201601081300.dat", argv[0]);
		printf("\n");
		return(-1);
	}

	sock = SetSocketTcp("127.0.0.1", 30010, 2, ebuf);

	if(sock == -1)
	{
		printf("Debug>>%s\n", ebuf);
		return(-1);
	}

	if((fp = fopen(argv[1], "rt"))==NULL) return(-1);

	while(1)
	{
		memset(tmp,0x00,sizeof(tmp));
		if(fgets(tmp, sizeof(tmp), fp)==NULL) break;

/*-------------------------------------------------------------------------
 Ź                                 
1) tcp/ip socket                                     
2) packet ڷ 3 byte  : ff(0xff) + cr(0x0d) + lf(0x0a)                                 
-------------------------------------------------------------------------*/

        for(kk=0; kk<MAX_TR_CNT; kk++)
		{
			if(memcmp(tmp, yesterday_udp_tr_cnt[kk].head, 5) == 0)
			{
				tmp[yesterday_udp_tr_cnt[kk].size-1] = 0x0a;
				tmp[yesterday_udp_tr_cnt[kk].size-2] = 0x0d;
				tmp[yesterday_udp_tr_cnt[kk].size-3] = 0xff;

				if(send(sock, tmp, yesterday_udp_tr_cnt[kk].size, 0) == -1)
				{
					printf("Debug>>Socket send Error!!\n");

                    if(fp != NULL) fclose(fp);
                    close(sock);
				    return(-1);	
				}


				break;
			}
		}

		usleep(4000);
	}

	if(fp != NULL) fclose(fp);
	close(sock);

	return(0);
}






